/*
   Zoran.h

   ZORAN ZR36120 module driver.
   Copyright (C) 1997  Vincent Labie (try ivsparis@pratique.fr with
				      for Vincent Labie in the suject)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef	ZORAN_H
#define	ZORAN_H

/**********************************************************************************************************************/

#include	<linux/config.h>
#include	<linux/module.h>
#include	<linux/mm.h>
#include	<linux/bios32.h>
#include	<linux/pci.h>
#include	<asm/irq.h>
#include	<linux/time.h>
#include	<linux/malloc.h>
#include	<linux/bigphysarea.h>
extern unsigned long loops_per_sec;
#include	<asm/io.h>
#include	<asm/delay.h>

/**********************************************************************************************************************/

#define		FALSE		0
#define		TRUE		1

typedef	int			BOOL;

/**********************************************************************************************************************/

#define		ZORAN_VERSION			0
#define		ZORAN_SUBVERSION		3
/*	local/experimental major					*/
/*	can be modified with module command line, see Zoran.c		*/
#define		ZORAN_MAJOR			60
#define		NB_MAX_ZORAN_CARD		4
#define		NB_MAX_ZORAN_SLOT		32

/*	debug level, for ZORAN, SAA and I2C operations			*/
/*	can be modified with module command line, see Zoran.c		*/
#define		ZORAN_ZRVERBOSE			0
#define		ZORAN_SAAVERBOSE		0
#define		ZORAN_I2CVERBOSE		0

/*	base values for EyeWay95 design, hardware dependant,		*/
/*	can be modified with module command line, see Zoran.c		*/
/*	Dir(0x7f:bit7 out, bit6-0 input), IO(bit7=1) -> unreset SAA7110	*/
#define		ZORAN_GENPURDIR			0x7f
#define		ZORAN_GENPURIO			0x80
#define		ZORAN_GIRQ			0
/*	values for interface with SAA7110				*/
#define		ZORAN_EXTFI			1
#define		ZORAN_TOPFIELD			1
#define		ZORAN_HSPOL			0
#define		ZORAN_VSPOL			1

enum	ZR_CAPMODE	{
			ZCM_STOP=0,
			ZCM_CONTINOUS,
			ZCM_3CONTINOUSHACK,
			ZCM_3CONTINOUS,
			ZCM_GRAB
			};

typedef	struct
	{
	u8		Bus;
	u8		dfn;
	u8		Irq;
	u8		IndexPCI;
	BOOL		bOpen;
	u8 *		pFrameBuffer;
	u32		FrameBufferSize;
	enum ZR_CAPMODE	ZRCapMode;
	int		NbSlot;
	int		CapSlot;
	int		UserSlot;
	u32		TabSlotOffset[NB_MAX_ZORAN_SLOT];
	int		TabSlotFilled[3];

	int		VideoStd;
	int		CapWidth;
	int		CapHeight;
	int		CapPixelBytes;
	int		CapScanLineSize;
	int		ScanLineSize;
	BOOL		bCrop;
	void *		pZR36120;
	}	ZORAN;

/**********************************************************************************************************************/

#include	"ZoranDBG.h"
#include	"ZoranIOCTL.h"

/**********************************************************************************************************************/
#endif	//ZORAN_H
